#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "Fish_GrandPrixRankingCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<Fish_GrandPrixRankingCFG> Fish_GrandPrixRankingCFG::msSingleton(nullptr);

int Fish_GrandPrixRankingCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_GrandPrixRankingCFGData* Fish_GrandPrixRankingCFG::GetData(int Id)
{
	auto it = mMapData.find(Id);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, Fish_GrandPrixRankingCFGData>& Fish_GrandPrixRankingCFG::GetMapData()
{
	return mMapData;
}

void Fish_GrandPrixRankingCFG::Reload()
{
	mMapData.clear();
	Load();
}

void Fish_GrandPrixRankingCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_GrandPrixRankingCFGData data;
		data.mId = element->IntAttribute("Id");
		data.mRankingType = element->IntAttribute("RankingType");
		data.mStartRank = element->IntAttribute("StartRank");
		data.mEndRank = element->IntAttribute("EndRank");
		{
			const char* RewardList = element->Attribute("RewardList");
			std::vector<std::string> vecRewardList;
			boost::split(vecRewardList, RewardList, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecRewardList.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecRewardList[i].c_str(), &temp))
				{
					data.mRewardList.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mId) != mMapData.end())std::cout <<"data refind:" << data.mId << std::endl;
		assert(mMapData.find(data.mId) == mMapData.end());
		mMapData.insert(std::make_pair(data.mId, data));
		element = element->NextSiblingElement();
	}
}

void Fish_GrandPrixRankingCFG::Load()
{
	Load("../Config/Fish_GrandPrixRankingCFG.xml");
}

Fish_GrandPrixRankingCFG* Fish_GrandPrixRankingCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_GrandPrixRankingCFG());
	}
	return msSingleton.get();
}
